local ft = require('freetype')()

local function loadFont()
	local fontData = assert(love.filesystem.newFileData('zrnic rg.ttf'))
	local face = ft:memory_face(fontData:getPointer(), fontData:getSize())
	face:set_char_size(0, 12 * 64)
	return face
end

local face = loadFont()

local glyphs, n = {}, 0
for i = 0, 255 do
	glyphs[i] = face:char_index(i)
	if glyphs[i] > 0 then n = n + 1 end
end
print(n, "glyphs")

for j = 1, 3 do
	love.image.newImageData(1024, 1024)
	collectgarbage() -- removing this line makes it work
end

n = 0
for i = 0, 255 do
	local index = face:char_index(i)
	assert(glyphs[i] == index, i .. ': ' .. glyphs[i] .. " ~= " .. index)
	if index > 0 then n = n + 1 end
end
print(n, "glyphs")

love.event.quit()
